module type S =
sig
  include Custom.T
  type elem

  val get: t -> (elem list * elem list) list

  val empty : t
  val full  : t
  val cup   : t -> t -> t
  val cap   : t -> t -> t
  val diff  : t -> t -> t
  val atom  : elem -> t

  val iter: (elem-> unit) -> t -> unit

  val compute: empty:'b -> full:'b -> cup:('b -> 'b -> 'b) 
    -> cap:('b -> 'b -> 'b) -> diff:('b -> 'b -> 'b) ->
    atom:(elem -> 'b) -> t -> 'b

  val print: string -> (Format.formatter -> elem -> unit) -> t ->
    (Format.formatter -> unit) list

  val trivially_disjoint : t -> t -> bool
end

module MakeOld(X : Custom.T) : S with type elem = X.t
module Make(X : Custom.T) : S with type elem = X.t


