type t = (Value.t * Types.t Lazy.t) list
exception Failed of t


val print: Format.formatter -> t -> unit
val to_string: t -> string

val simplify: t -> t
val explain: Types.t -> Types.t -> Value.t -> t option
  (** [explain t0 t v] 
    Return a path on [v] that explains why [v] is not of type [t],
    or [None] if [v] has type [t].
    [v] is assumed to have type [t0].
  *)

val check: Types.t -> Types.t -> Value.t -> unit
  (** Same, but raise [Failed].
      A partial appliaction to the first two argument will precompute
      the internal automaton. *)

